package net.binzume.android.nicoplayer;


import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;
import net.binzume.android.nicoplayer.api.NicoSession;

public class NicoPlayerTop extends Activity {
    
    public static NicoSession session;
    
    
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.wait);

        Log.d("nicoplayer","start");
        
        //RankingAPI.getTop();
        
        // load pref
        SharedPreferences sp = PreferenceManager.getDefaultSharedPreferences(this);

        Intent intent = getIntent();
        if (intent.getAction().equals("login_failed")) {
            Intent intent2 = new Intent(this, AccountPref.class);
            startActivityForResult(intent2, 123);
        } else {
            String mailaddress = sp.getString("mailaddress", "");
            String password = sp.getString("password", "");
    
            if (mailaddress == null || mailaddress.length() == 0 || password.length() == 0 ) {
                // ݒȂ
/*                
                new AlertDialog.Builder(NicoPlayerTop.this)
                .setTitle("()jRjRvC[()")
                .setMessage("܂Ĵߑ̖肪cĂ܂D" +
                		"mFEoOɂ͂肢v܂D\n" +
                		"ӂċNꍇOKĂ")
                .setPositiveButton("OK",new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int which) {
                        Intent intent2 = new Intent(NicoPlayerTop.this, AccountPref.class);
                        startActivityForResult(intent2, 123);
                    }
                })
                .setNegativeButton("Cancel",new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int which) {
                        NicoPlayerTop.this.finish();
                    }
                })
                .show();
/*/
                Intent intent2 = new Intent(NicoPlayerTop.this, AccountPref.class);
                startActivityForResult(intent2, 123);
//*/
            } else {
                LoginTask login = new LoginTask(this);
                login.execute(mailaddress, password);
            }
        }

        
    }
    
    public void menu(NicoSession s){
        if (s==null) {
            Toast.makeText(this, "Login failed", Toast.LENGTH_LONG).show();  
            Intent intent2 = new Intent(this, AccountPref.class);
            startActivityForResult(intent2, 123);
            return;
        }
        
        setContentView(R.layout.main);
        Button b1 = (Button)this.findViewById(R.id.Button02);
        b1.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                Intent intent = new Intent(NicoPlayerTop.this, MyListActivity.class);
                intent.putExtra("list","default");
                startActivity(intent);
            }
        });

        Button mylistbtn = (Button)this.findViewById(R.id.MylistButton);
        mylistbtn.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                Intent intent = new Intent(NicoPlayerTop.this, MyListActivity.class);
                startActivity(intent);
            }
        });

        Button b2 = (Button)this.findViewById(R.id.AccountButton);
        b2.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                Intent intent = new Intent(NicoPlayerTop.this, AccountPref.class);
                startActivityForResult(intent, 123);
            }
        });
        
        ((Button)this.findViewById(R.id.RankingButton))
           .setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                Intent intent = new Intent(NicoPlayerTop.this, VideoListActivity.class);
                startActivity(intent);
            }
        });
        ((Button)this.findViewById(R.id.NanikaButton))
        .setOnClickListener(new OnClickListener() {
         public void onClick(View v) {
             new AlertDialog.Builder(NicoPlayerTop.this)
             .setTitle("()jRjRvC[()")
             .setPositiveButton("OK",null)
             .show();
         }
        });

             
        ((Button)this.findViewById(R.id.SearchButton))
        .setOnClickListener(new OnClickListener() {
         public void onClick(View v) {
             final EditText keywordText = new EditText(NicoPlayerTop.this);
             keywordText.setSingleLine();
             new AlertDialog.Builder(NicoPlayerTop.this)
             .setIcon(R.drawable.icon)
             .setTitle("^O")
             .setView(keywordText)
             .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                 public void onClick(DialogInterface dialog, int whichButton) {
                     Intent intent = new Intent(NicoPlayerTop.this, VideoListActivity.class);
                     intent.putExtra("mode", "tag");
                     intent.putExtra("keyword", keywordText.getText().toString());
                     startActivity(intent);
                 }
             })
             .setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
                 public void onClick(DialogInterface dialog, int whichButton) {
                 }
             })
             .show();
         }
     });
        
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data){
        switch(requestCode){
            case 123:
                SharedPreferences sp = PreferenceManager.getDefaultSharedPreferences(this);
                String mailaddress = sp.getString("mailaddress", "");
                String password = sp.getString("password", "");

                if (mailaddress == null || mailaddress.length() == 0 || password.length() == 0) {
                    finish();
                    return;
                }

                LoginTask login = new LoginTask(this);
                login.execute(mailaddress, password);
                break;
            default:
                finish();
        }
    }

}