/**
 * ニコニコ コメント API
 * 
 * 怪しい・・・
 * 
 * @author binzume <kawahira__binzume.net>
 */

package net.binzume.android.nicoplayer.api;

import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import android.util.Log;

public class CommentAPI {

    public static ThreadInfo get(NicoSession session,VideoInfo vi){
        HttpClient client = new HttpClient();
        client.setCookie(session.cookie);
        

        Log.d("nicoplayer","ms:"+vi.messageServer);
        Log.d("nicoplayer","ti:"+vi.threadId);

        if(!client.get("http://flapi.nicovideo.jp/api/getthreadkey?thread="+vi.threadId)){
            return null;
        }
        String data = client.getContent();        
        HashMap<String, String> info = new HashMap<String, String>();
        String[] params = data.split("&");
        for(int i = 0 ; i < params.length ; i++){
            String[] p = params[i].split("=");
            if (p.length < 2) continue;
            info.put(URLDecoder.decode(p[0]), URLDecoder.decode(p[1]));
        }
        String postdata;
        long userId = session.userId;
        if (info.get("threadkey") != null && info.get("threadkey").length()>0) {
            postdata= "<packet><thread thread=\"" +vi.threadId+ "\" version=\"20090904\" user_id=\""+userId+"\" threadkey=\""+ info.get("threadkey") 
                    + "\" force_184=\""+info.get("force_184")+"\"/><thread_leaves thread=\""+ vi.threadId +"\" user_id=\""+userId+"\" threadkey=\""
                    + info.get("threadkey") + "\" force_184=\""+info.get("force_184")+"\">0-99:100</thread_leaves></packet>";
        } else {
            postdata= "<packet><thread thread=\"" +vi.threadId+ "\" version=\"20090904\" user_id=\""+userId
                    +"\"/><thread_leaves thread=\""+ vi.threadId +"\" user_id=\""+userId+"\">0-99:100</thread_leaves></packet>";
            //postdata = "<thread res_from=\"-500\" version=\"20061206\" thread=\""+ vi.threadId +"\" />";
        }

        if(!client.post(vi.messageServer,postdata)){
            return null;
        }
        data = client.getContent();        

        ThreadInfo ti = new ThreadInfo();
        ti.threadId = vi.threadId;
        ti.url = vi.messageServer;
        
        // fixme...
        {
            Pattern pattern = Pattern.compile("<thread[^>]*? last_res=\"(\\d+)\"");
            Matcher matcher = pattern.matcher(data);
            if (matcher.find()) {
                ti.lastRes = Integer.parseInt(matcher.group(1));
            }
        }
        {
            Pattern pattern = Pattern.compile("<thread[^>]*? ticket=\"(\\w+)\"");
            Matcher matcher = pattern.matcher(data);
            if (matcher.find()) {
                ti.ticket = matcher.group(1);
            }
        }
        
        ti.comments = new LinkedList<CommentInfo>();
        Pattern pattern = Pattern.compile("<chat([^>]* vpos=\"(\\d+)\"[^>]*)>([^<]+)</chat>");
        Matcher matcher = pattern.matcher(data);
    
        while (matcher.find()) {
            CommentInfo c = new CommentInfo();
            c.vpos =  Integer.parseInt(matcher.group(2));
            c.message =  matcher.group(3);
            ti.comments.add(c);
            Pattern pattern2 = Pattern.compile("mail=\"([^\"]*)\"[^>]* user_id=\"([^\"]*)\"");
            Matcher matcher2 = pattern2.matcher(matcher.group());
            if (matcher2.find()) {
                c.mail =  matcher2.group(1);
                c.userId =  matcher2.group(2);
            } else {
                c.mail = "";
            }

        }
        Log.d("nicoplayer","comments: "+ti.comments.size());
        return ti;
    }
    public static boolean postComment(NicoSession session, ThreadInfo ti, int vpos, String str){
        HttpClient client = new HttpClient();
        client.setCookie(session.cookie);

        String postkey = getPostKey(client,ti.lastRes/100,ti.threadId);

        String postdata;
        long userId = session.userId;
        postdata = "<chat thread=\""+ti.threadId+"\" vpos=\""+vpos+"\" mail=\"184 \" ticket=\""+ti.ticket
                    +"\" user_id=\""+userId+"\" postkey=\""+postkey+"\" premium=\""+session.isPremium+"\">"+str+"</chat>";

//*        
        if(!client.post(ti.url, postdata)){
            Log.d("nicoplayer","request:"+postdata);
            return false;
        }
        String data = client.getContent();
        {
            Pattern pattern = Pattern.compile("<chat_result[^>]*? status=\"0\"");
            Matcher matcher = pattern.matcher(data);
            if (matcher.find()) {
                return true;
            }
        }
        Log.d("nicoplayer","response:"+data);
//*/
//      Log.d("nicoplayer","param:"+ti.url+","+ti.lastRes/100+","+ti.threadId);
        Log.d("nicoplayer","request:"+URLEncoder.encode(postdata));
        return false;
    }
    
    private static String getPostKey(HttpClient client,int bn,String ti) {
        // 
        if(!client.get("http://flapi.nicovideo.jp/api/getpostkey/?block_no="+bn+"&yugi=&thread="+ti)){
            return null;
        }
        String data = client.getContent();
        
        String s[] = data.split("=");
        if (s[0].equals("postkey")) {
            return s[1];
        }

        return null;
    }
    
}
